<template>
  <div class="card shadow-sm">
    <form id="formItems" class="needs-validation" novalidate>
      <div class="card-header">
        <h3 class="card-title" style="font-size: 20px; font-weight: bold">
          เพิ่มสาขา
        </h3>
      </div>
      <!-- form -->
      <div class="card-body">
        <!-- -->
        <div class="row d-flex justify-content-center mb-4">
          <label for="validationTooltip01" class="required form-label col-sm-10"
            >ชื่อสาขา</label
          >
          <div class="col-sm-10">
            <input
              v-model="formCompany.company_branch_name"
              type="text"
              class="form-control"
              id="validationTooltip01"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>
        <!-- <div class="row d-flex justify-content-center mb-4">
          <label for="validationTooltip01" class="form-label col-sm-10"
            >ประเภทสาขา</label
          >
          <div class="col-sm-10">
            <input
              v-model="formCompany.company_type"
              type="text"
              class="form-control"
              id="validationTooltip01"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div> -->
        <div class="row d-flex justify-content-center mb-4">
          <label for="validationTooltip01" class="form-label col-sm-10"
            >ที่อยู่สาขา</label
          >
          <div class="col-sm-10">
            <textarea
              v-model="formCompany.company_branch_address"
              type="text"
              class="form-control"
              id="validationTooltip01"
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>
        <div class="row d-flex justify-content-center mb-4">
          <label for="validationTooltip01" class="form-label col-sm-10"
            >เบอร์โทรศัพท์สาขา</label
          >
          <div class="col-sm-10">
            <input
              v-model="formCompany.company_branch_tel"
              type="text"
              class="form-control"
              id="validationTooltip01"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>
        <div class="row d-flex justify-content-center mb-4">
          <label for="validationTooltip01" class="form-label col-sm-10"
            >Tax ID</label
          >
          <div class="col-sm-10">
            <input
              v-model="formCompany.tax_id"
              type="text"
              class="form-control"
              id="validationTooltip01"
            />
          </div>
        </div>
        <div class="row d-flex justify-content-center mb-4">
          <label for="validationTooltip01" class="form-label col-sm-10"
            >อีเมลสาขา</label
          >
          <div class="col-sm-10">
            <input
              v-model="formCompany.company_branch_email"
              type="text"
              class="form-control"
              id="validationTooltip01"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>
        <div class="row d-flex justify-content-center">
          <label for="validationTooltip01" class="form-label col-sm-10"
            >ไลน์ไอดีกิจการ</label
          >
          <div class="col-sm-10">
            <input
              v-model="formCompany.company_branch_line_id"
              type="text"
              class="form-control"
              id="validationTooltip01"
              required
            />
            <div class="invalid-feedback text-end">กรุณากรอก</div>
          </div>
        </div>
      </div>

      <hr class="pt-0 mt-0" style="color: LightGrey" />

      <footer class="m-6">
        <div class="card-toolbar row justify-content-center">
          <div class="col-sm-10">
            <button
              type="submit"
              class="btn btn-sm btn-light btn-primary ms-3 me-2"
              style="font-size: 14px; font-weight: bold"
              @click="submit"
              :disabled="loading"
            >
              <div
                v-if="loading"
                class="spinner-grow spinner-grow-sm text-light"
                role="status"
              ></div>
              บันทึก
            </button>
            <button
              type="button"
              class="btn btn-sm btn-light"
              style="font-size: 14px; font-weight: bold"
              @click="cancel"
            >
              ยกเลิก
            </button>
          </div>
        </div>
      </footer>
    </form>
  </div>
</template>

<script>
import loginApi from "@/api/user/";
import companyApi from "@/api/user/";

import Swal from "sweetalert2/dist/sweetalert2.js";
import whApi from "@/api/warehouse/";
import { Decode, Encode } from "@/services";

export default {
  setup() {
    document.title = "BELUCA | เพิ่มคลังสินค้า";
  },
  data() {
    return {
      loading: false,
      isSubmit: false,

      formCompany: {
        company_branch_name: "",
        tax_id: "",
        company_branch_address: "",
        company_branch_tel: "",
        company_branch_email: "",
        company_branch_line_id: "",
        digital_address: "",
      },

      ccsSelect: `background-size: 16px 12px;background-position: right 1rem center;background-repeat: no-repeat;background-image: url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill='none' stroke='%237E8299' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='M2 5l6 6 6-6'/%3e%3c/svg%3e")`,
    };
  },
  created() {
    this.generateData();
  },
  methods: {
    async generateData() {
      const response = await companyApi.company.generateNewData();

      if (response.response_status === "SUCCESS") {
        this.formCompany.company_business_id =
          response.data.company_business_id;
        this.formCompany.digital_address = response.data.digital_address;
      }
    },

    async submit() {
      let createResponse = [];

      await this.validateForm();
      await this.checkFormIsEmpty();

      this.isSubmit = true;
      const userId = Decode.decode(localStorage.getItem("boss"));

      if (this.isValid) {
        this.loading = true;

        this.formCompany = {
          ...this.formCompany,
          companyId: parseInt(localStorage.getItem("companyId")),
          companyBranchId: parseInt(localStorage.getItem("companyBranchId")),
          createBy: userId,
        };

        createResponse = await loginApi.companyBranch.create(this.formCompany);
        if (createResponse.response_status === "SUCCESS") {
          Swal.fire({
            icon: "success",
            title: "เพิ่มสำเร็จ",
            showConfirmButton: false,
            timer: 1500,
          }).then(() => {
            this.$router.push({
              path: "/setting/company-branch",
              query: {},
            });
          });
          this.loading = false;
        } else {
          Swal.fire({
            icon: "error",
            title: "เพิ่มไม่สำเร็จ !",
            showConfirmButton: false,
            timer: 1500,
          });
          this.loading = false;
        }
      }
    },

    checkFormIsEmpty() {
      !this.formCompany.company_branch_name
        ? (this.isValid = false)
        : !this.formCompany.company_branch_tel
        ? (this.isValid = false)
        : !this.formCompany.company_branch_email
        ? (this.isValid = false)
        : !this.formCompany.company_branch_line_id
        ? (this.isValid = false)
        : (this.isValid = true);
    },

    validateForm() {
      let forms = document.querySelectorAll(".needs-validation");
      Array.prototype.slice.call(forms).forEach(function (form) {
        form.addEventListener(
          "submit",
          function (event) {
            if (!form.checkValidity()) {
              event.preventDefault();
              event.stopPropagation();
            }

            form.classList.add("was-validated");
          },
          false
        );
      });
    },

    cancel() {
      this.$router.push({
        path: "/setting/company-branch",
        query: {},
      });
    },
  },
};
</script>
